/*
#    rp
#    Copyright (C) 2007  Ingemar Ceicer
#    http://ceicer.org/ingemar/
#    programmering (at) ceicer (dot) org

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3, as published by
#    the Free Software Foundation.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
*/

#include <string>
#include <iostream>
#include <fstream>
#include <vector>
#include "conf.h"
#include "iodos.h" //DOS only
using namespace std;

string get_fil();
string get_help(char *c,char *p);
int main(int argc, char** argv)
{
dos_console(850); //DOS only
int g,i;
string filnamn;
string rad,rep_rad;
vector<string> *hela_lasfilen = new vector<string>;
vector<string>::iterator it;
ifstream lasfil;
ofstream skrivfil;


Conf *cnf = new Conf;

switch (argc)
{
	case 1:
	filnamn = get_fil();
	break;
	case 2:
	filnamn = get_help(argv[1],argv[0]);
	break;
	default:
	cout << "Error. " << "Usage: " << argv[0] << " Or " << argv[0] << " file_name" << endl;
	system("PAUSE");//DOS only

	exit(1);
}


lasfil.open(&filnamn[0],ios::in);


if (lasfil.is_open())
{
while ( ! lasfil.eof() )
{
	getline (lasfil,rad);
	i=0;
	g = rad.size();
	while (i <= g)
	{
		rep_rad = cnf->getReplacement(rad);
			if (rep_rad != "")
			{
				rad.erase(cnf->getPosition(),cnf->getOldLangd());
				rad.insert(cnf->getPosition(), rep_rad);

			}
	i++;
	g = rad.size();
	}
hela_lasfilen->push_back(rad);

}
lasfil.close();
skrivfil.open(&filnamn[0],ios::out);
if (skrivfil.good())
{
	for (it=hela_lasfilen->begin();it < hela_lasfilen->end();it++)
	{
		skrivfil << *it;
		if (it < (hela_lasfilen->end() - 1))
			skrivfil << endl;
	}
delete hela_lasfilen;
}
else
{
	cout << "Error while writing to file" << endl;
	system("PAUSE");//DOS only
	exit(1);
}

skrivfil.close();
}
else
{	cout << "Unable to open file" << endl;
  system("PAUSE");//DOS only
	exit(1);
}
cnf->statistik(&filnamn);
delete cnf;
system("PAUSE");//DOS only
return 0;
}

string get_fil()
{
	string s;
	cout << "Select a file :>";
	cin >> s;
	return s;
}

string get_help(char *c,char *prog)
{
	string s = (string) c;
	if (s == "--help")
	{
		cout << "Usage: " << prog << " Or " << prog << " file_name" << endl;
     system("PAUSE");//DOS only	
		exit(1);
	}
	return s;
}
